﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using SilverMotion.IO.FileImage;
using SilverMotion.EnvironmentTypes;
using System.IO;

namespace PictureFrame
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void buttonOpen_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                OpenFileDialog dlg = new OpenFileDialog();
                dlg.Filter = "Images (*.jpg; *.png)|*.jpg;*.png|All Files (*.*)|*.*";
                if (dlg.ShowDialog() == true)
                {
                    // Load the opened picture file as a texture into the RenderEnvironment
                    environment.LoadTexture(new FileImage(dlg.File.OpenRead(), dlg.File.Name), false);

                    // Find the RenderBranch named "Picture" in the model. That is the plane, which will be use to map the texture onto.
                    MaterialResource material = environment.Hierarchy.Find("Picture").MaterialReference;
                    material.ClearShaders();
                    material.AddShader(VertexShader.Lighting, ShaderColorOperation.Add);
                    material.AddShader(TextureShader.ColorMap, ShaderColorOperation.Modulate, environment.LoadedResources.FindTexture(dlg.File.Name, false));

                    environment.Update();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message + Environment.NewLine + ex.StackTrace, "Error", MessageBoxButton.OK);
            }
        }
    }
}
