﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Shapes;
using SilverMotion;
using SilverMotion.EnvironmentTypes;
using SilverMotion.Motions;

namespace Skins
{
    public partial class MainPage : UserControl
    {
        RenderBranch selectedBranch;
        BaseMotion motion;
        bool closed;

        public MainPage()
        {
            InitializeComponent();
        }

        private void renderEnvironment1_MeshPicked(object sender, SilverMotion.EnvironmentTypes.MeshPickedEventArgs e)
        {
            selectedBranch = e.Mesh;
            textBlockSelection.Text = selectedBranch.MaterialReference.UniqueName;
        }

        private void rectangleColor_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            if (selectedBranch == null)
                return;

            selectedBranch.MaterialReference.DiffuseColor = ((SolidColorBrush)((Rectangle)(sender)).Fill).Color;

            environment.Update();
        }

        private void buttonOpenClose_Click(object sender, RoutedEventArgs e)
        {
            buttonOpenClose.IsEnabled = false;

            if (closed)
                motion = environment.StartMotion(new KeyframeMotion(environment.Hierarchy, 30, 0, 30, false));
            else
                motion = environment.StartMotion(new KeyframeMotion(environment.Hierarchy, 0, 30, 30, false));
        }

        private void environment_MotionTerminated(object sender, MotionTerminatedEventArgs e)
        {
            if (e.TerminatedMotion != motion)
                return;

            closed = !closed;

            if (closed)
                buttonOpenClose.Content = "Open cap";
            else
                buttonOpenClose.Content = "Close cap";

            buttonOpenClose.IsEnabled = true;
        }
    }
}
